modelling a house, some Arch issues

A forum dedicated to the Draft, Arch and BIM workbenches development.
Forum rules
Be nice to others! Respect the FreeCAD code of conduct!
jmaustpc
Veteran
Posts: 11207
Joined: Tue Jul 26, 2011 6:28 am
Location: Australia

modelling a house, some Arch issues

Post by jmaustpc »

Hi Yorik and all
I just tried to model a small relocatable house with Arch WB, and generally it worked quite well. The last time I tried this was a long time ago.

So I thought I would post here for starters to say thanks for all your work Yorik, the workbench is great. :) And then I will post some issues I discovered.

Merge Walls doesn't seem to work or not work reliably. When I based my walls on path as defined by lines in Sketcher, Join Walls did not do anything. I tried a few random tests with DLine and Dwire with varying correct or incorrect results. I am trying to work out what combination is doing what, I'll write back about that later.

Roof I honestly can not understand. Also If I draw a closed rectangular Dwire (for example 14m x 6m) on z=0 xy plane I get a default strange looking Roof with no errors but if I have the Dwire above z=0 then I get an error message and not roof. Here is the error message for the following file if you make a roof on Dwire002
roof_experiments.fcstd
(20.11 KiB) Downloaded 78 times

Code: Select all

le contour contient 4 aretes
PROFIL 0 : Start calculs
Next : ht2 < ht1
a Vector (14168.0996094, -1.9999999999990905, 2400.0)
d Vector (18258.938232445, 4088.838623045002, 2400.0)
e Vector (18258.938232445, 7085.049804700002, 2400.0)
Back : ht0 < ht1
a Vector (-4088.838623045, 7085.0498047, 2400.0)
b Vector (-4088.838623045, 4088.8386230449996, 2400.0)
c Vector (2.0000000000009095, -2.0000000000009095, 2400.0)
('ptsPaneProject', [Vector (14168.0996094, -1.9999999999990905, 2400.0), Vector (18258.938232445, 4088.838623045002, 2400.0), Vector (18258.938232445, 7085.049804700002, 2400.0), Vector (-4088.838623045, 7085.0498047, 2400.0), Vector (-4088.838623045, 4088.8386230449996, 2400.0), Vector (2.0000000000009095, -2.0000000000009095, 2400.0)])
PROFIL 0 : End calculs
PROFIL 1 : Start calculs
Next : ht2 > ht1
a Vector (14168.0996094, -8175.677246089999, 2400.0)
d Vector (18258.938232445, -12266.515869135, 2400.0)
e Vector (18258.938232445, -15262.72705079, 2400.0)
Back : ht1 < ht0
a Vector (18258.938232445, 4088.838623045002, 2400.0)
c Vector (14168.0996094, -1.9999999999990905, 2400.0)
d Vector (14168.0996094, 0.0, 0.0)
('ptsPaneProject', [Vector (14168.0996094, -8175.677246089999, 2400.0), Vector (18258.938232445, -12266.515869135, 2400.0), Vector (18258.938232445, -15262.72705079, 2400.0), Vector (18258.938232445, 4088.838623045002, 2400.0), Vector (14168.0996094, -1.9999999999990905, 2400.0), Vector (14168.0996094, 0.0, 0.0)])
PROFIL 1 : End calculs
Traceback (most recent call last):
  File "/home/user/Downloads/cad/freecad_master/build_master_Release_newgcc_blobfishOCE691_tbb_gl2ps_freeimg/Mod/Arch/ArchRoof.py", line 593, in execute
    f = Part.Face(wire)
<class 'Part.OCCError'>: Failed to create face from wire
I have to run now, I'll be back in a few hours...

Jim

OS: Ubuntu 12.04.5 LTS
Word size of OS: 64-bit
Word size of FreeCAD: 64-bit
Version: 0.16.6431 (Git)
Build type: Release
Branch: master
Hash: 69c241ba8972b6b4b89d0a33e2e5eb4c3a7889f7
Python version: 2.7.3
Qt version: 4.8.2
Coin version: 3.1.3
OCC version: 6.9.1.oce-0.18-dev
damian
Posts: 583
Joined: Sun May 31, 2015 6:16 pm

Re: modelling a house, some Arch issues

Post by damian »

hello jmaustpc:

Recently I drawn a little house. At the beginning, I didn't understand the roof tool. But now it is working very well for me.

I've opened your file. I'm looking the roof001, based in Dwire002. Did you draw the Dwire002 in counter clockwise???

I can't deal with the roof1. But I can draw a new my_Dwire (counter clockwise) and make a new my_roof, inside your file. Later it requires to play with Run and Height in order to obtain a nice roof.

The merge walls seems to be working. I'll see it slower during the day.

Relative to the error message, in another situation with another tool, I've got the same strange message, but it doesn't seem to hurt (for the moment)
jmaustpc
Veteran
Posts: 11207
Joined: Tue Jul 26, 2011 6:28 am
Location: Australia

Re: modelling a house, some Arch issues

Post by jmaustpc »

here is a very simple example of two walls from sketches that will not merge
simplewallmergefailureexample3.fcstd
(11.05 KiB) Downloaded 73 times
failedmergewall.jpeg
failedmergewall.jpeg (17.01 KiB) Viewed 3053 times
I get this error message

Code: Select all

Running the Python command 'Arch_MergeWalls' failed:
Traceback (most recent call last):
  File "/home/user/Downloads/cad/freecad_master/build_master_Release_newgcc_blobfishOCE691_tbb_gl2ps_freeimg/Mod/Arch/ArchWall.py", line 406, in Activated
    FreeCADGui.doCommand("Arch.joinWalls(FreeCADGui.Selection.getSelection(),delete=True)")
  File "<string>", line 1, in <module>
  File "/home/user/Downloads/cad/freecad_master/build_master_Release_newgcc_blobfishOCE691_tbb_gl2ps_freeimg/Mod/Arch/ArchWall.py", line 103, in joinWalls
    FreeCAD.ActiveDocument.removeObject(n)

No document object found with name 'Wall001'
and a very similar file that did work, I just deleted the horizontal second section of the inner wall's path in the sketch
simplewallmergefailureexample3_worked.fcstd
(11.97 KiB) Downloaded 54 times
successfullmergewall1.jpeg
successfullmergewall1.jpeg (15.8 KiB) Viewed 3053 times
jmaustpc
Veteran
Posts: 11207
Joined: Tue Jul 26, 2011 6:28 am
Location: Australia

Re: modelling a house, some Arch issues

Post by jmaustpc »

damian wrote:Recently I drawn a little house. At the beginning, I didn't understand the roof tool. But now it is working very well for me.
could you post an example FCstd file with a roof that worked?
User avatar
rockn
Veteran
Posts: 1791
Joined: Wed Sep 28, 2011 10:39 am
Location: Toulouse, France
Contact:

Re: modelling a house, some Arch issues

Post by rockn »

Hi Jim,
Yes, I know that Roof tool is not very robust nor very intuitive to use.
But I will need some insane engineer to developp a powerfull Roof builder like I like to use in wood construction software :(

This is my working example that I use to developp this "new" roof tool.
RoofExample.fcstd
(39.92 KiB) Downloaded 82 times
Formations - Assistance - Développement : https://freecad-france.com
jmaustpc
Veteran
Posts: 11207
Joined: Tue Jul 26, 2011 6:28 am
Location: Australia

Re: modelling a house, some Arch issues

Post by jmaustpc »

rockn wrote:Hi Jim,
Yes, I know that Roof tool is not very robust nor very intuitive to use.
But I will need some insane engineer to developp a powerfull Roof builder like I like to use in wood construction software :(

This is my working example that I use to developp this "new" roof tool.
house_2bed_5.fcstd
(374.51 KiB) Downloaded 88 times
thanks rockn
OK but if its helpful.......If I try to make a roof based on your roof's profile I just get the following error

Code: Select all

Traceback (most recent call last):
  File "/home/user/Downloads/cad/freecad_master/build_master_Release_newgcc_blobfishOCE691_tbb_gl2ps_freeimg/Mod/Arch/ArchRoof.py", line 593, in execute
    f = Part.Face(wire)
<class 'Part.OCCError'>: Failed to create face from wire
If I create a similar profile it either just gives me an error or otherwise if makes a roof with the panel going the wrong way down and away from the walls like a veranda and leaves a hole in the middle, the overhang is added to the centre hole rather than outside the wall.

So I was wondering if something else is wrong? Some new bug making it less reliable than normal.

I noticed that your sample does not generate a slab/face on the 90 degree end, I had that problem as well.

For my house, it has a straight Gable roof so I just made two Pads in the end.

Here is the basic file, I made a solid to represent a rough approximation of the ground contours.
house_2bed_5.fcstd
(374.51 KiB) Downloaded 88 times
smallhouse.jpeg
smallhouse.jpeg (45.37 KiB) Viewed 3037 times
User avatar
rockn
Veteran
Posts: 1791
Joined: Wed Sep 28, 2011 10:39 am
Location: Toulouse, France
Contact:

Re: modelling a house, some Arch issues

Post by rockn »

jmaustpc wrote:If I try to make a roof based on your roof's profile I just get the following error
jmaustpc wrote: If I create a similar profile it either just gives me an error or otherwise if makes a roof with the panel going the wrong way down and away from the walls like a veranda and leaves a hole in the middle, the overhang is added to the centre hole rather than outside the wall.
More or less normal...Once you start editing the roof with right value the roof can be generated. This happen because I made the tool to generate a well shape for a rectangle based wire. But I have an idea to avoid that.
jmaustpc wrote:I noticed that your sample does not generate a slab/face on the 90 degree end, I had that problem as well.
That's intended, to create the gable you can extend the height of the wall slightly higher than the roof and make an Arch substraction between roof and wall.
But I noticed the subShape is not quite high, I will fix that.
Formations - Assistance - Développement : https://freecad-france.com
damian
Posts: 583
Joined: Sun May 31, 2015 6:16 pm

Re: modelling a house, some Arch issues

Post by damian »

Attachments
corregido.fcstd
(282.7 KiB) Downloaded 111 times
damian
Posts: 583
Joined: Sun May 31, 2015 6:16 pm

Re: modelling a house, some Arch issues

Post by damian »

Attachments
simplewallmergefailureexample3(join_sketchs_before_make_wall).fcstd
(8.82 KiB) Downloaded 115 times
User avatar
rockn
Veteran
Posts: 1791
Joined: Wed Sep 28, 2011 10:39 am
Location: Toulouse, France
Contact:

Re: modelling a house, some Arch issues

Post by rockn »

Hi everyone, hi Jim,

In this pull request : https://github.com/FreeCAD/FreeCAD/pull/108 I made some improvements in roof object.
This is the workflow :
Create a DWire on a horizontal plan.
Roof01.png
Roof01.png (415.4 KiB) Viewed 2903 times
Select it and make a Roof object. The default value are now fixed (was calculated before).
Roof02.png
Roof02.png (409.57 KiB) Viewed 2903 times
With a little bit of adjustement you can get this :
Roof03.png
Roof03.png (308.14 KiB) Viewed 2903 times
Now for the wall below, make it higher than the top of the roof.
Roof04.png
Roof04.png (46.26 KiB) Viewed 2903 times
Then select Roof and Wall in this order and click the RemoveComponent button (blue minus)
Roof05.png
Roof05.png (66.97 KiB) Viewed 2903 times
Formations - Assistance - Développement : https://freecad-france.com
Post Reply